' ================================================================================================
'  SERIAL TESTER
' ================================================================================================
'  This script sends data to a serial port
' ================================================================================================

' --------------------------------------- COM-PORT number and SLOT number
Const PortNumber As Short = 6
Const SlotNumber As Short = 0

Sub Main(ByVal s() As String)
	if Form1 IsNot Nothing then return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	Open_ComPort()
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	Timer1.Stop
	Close_ComPort()
End Sub

Private WithEvents comPort As New System.IO.Ports.SerialPort()

Private Sub Open_ComPort()
	' -------------------------------------------- If the port is Open then close it
	Close_ComPort()
	' -------------------------------------------- Set PORT and SPEED
	comPort.PortName = "COM" & PortNumber.ToString
	comPort.BaudRate = 9600
	comPort.Parity = System.IO.Ports.Parity.None
	comPort.DataBits = 8
	comPort.StopBits = System.IO.Ports.StopBits.One
	' -------------------------------------------- Set port params
	'comPort.InputLen = 5 '(no equivalent in VbNet)
	comPort.ReceivedBytesThreshold = 5
	'comPort.ReadBufferSize = 5 '(default = 4096)
	' -------------------------------------------- Disable DTR
	comPort.DtrEnable = False
	' -------------------------------------------- Try to open the port
	Try
		comPort.Open()
		comPort.DiscardOutBuffer
		comPort.DiscardInBuffer

		
		
		Label1.Text = "COM-Port " & PortNumber.ToString & " is opened"
		'Label1.Text &= " - Transferring serial data to Slot " & SlotNumber.ToString 
	Catch
		Label1.Text = "ERROR - Can not open COM-Port " & PortNumber.ToString
	End Try
End Sub

Private Sub Close_ComPort()
	If comPort.IsOpen Then
		comPort.Close()
	End If
End Sub



Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	'static counter as int32
	'counter +=333
	'if counter > 65535 then counter = 0
	'comPort.WriteLine(counter.ToString)
End Sub

Sub TrackBar1_Scroll(ByVal sender As Object, ByVal e As EventArgs) Handles TrackBar1.Scroll
	TrackBar1_Scroll(TrackBar1.Value)
End Sub

Sub TrackBar1_Scroll(value As Single)
	Label3.Text = "E' stato mosso il cursore, il suo valore e': " & value.ToString("0")
	comPort.WriteLine(value.ToString("0"))
	System.Threading.Thread.Sleep(50)
End Sub




' ---------------------------------------------------------------------- User Interface Components
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim objThread As Threading.Thread
Dim Label1 As Label = new Label
Dim Label2 As Label = new Label
Dim Label3 As Label = new Label
Dim Label4 As Label = new Label
WithEvents TrackBar1 As TrackBar = new TrackBar

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Serial Tester"
	Form1.ClientSize = New System.Drawing.Size(640, 320)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(10, 10)
	Label1.Font = New Font("Arial", 12 )
	Label1.Size = New Size(620, 21)
	Label1.Anchor = AnchorStyles.top or AnchorStyles.Left or AnchorStyles.right
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Label 2
	Label2.BorderStyle = BorderStyle.Fixed3D
	Label2.Location = New Point(10, 40)
	Label2.Font = New Font("Arial", 12 )
	Label2.Size = New Size(620, 21)
	Label2.Anchor = AnchorStyles.top or AnchorStyles.Left or AnchorStyles.right
	Form1.Controls.Add(Label2)	
	' ------------------------------------------------------------------ Label 3
	Label3.BorderStyle = BorderStyle.Fixed3D
	Label3.Location = New Point(10, 70)
	Label3.Font = New Font("Arial", 12 )
	Label3.Size = New Size(620, 21)
	Label3.Anchor = AnchorStyles.top or AnchorStyles.Left or AnchorStyles.right
	Form1.Controls.Add(Label3)	
	' ------------------------------------------------------------------ Label 4
	Label4.BorderStyle = BorderStyle.Fixed3D
	Label4.Location = New Point(10, 100)
	Label4.Font = New Font("Arial", 12 )
	Label4.Size = New Size(620, 21)
	Label4.Anchor = AnchorStyles.top or AnchorStyles.Left or AnchorStyles.right
	Form1.Controls.Add(Label4)
	' ------------------------------------------------------------------ TrackBar 1
	TrackBar1.Location = New Point(10, 130)
	TrackBar1.Size = New Size(45, 149)
	TrackBar1.Orientation = Orientation.Vertical
	TrackBar1.TickStyle = TickStyle.Both
	TrackBar1.Maximum = 1000
	TrackBar1.TickFrequency = 100
	TrackBar1.LargeChange = 10
	Form1.Controls.Add(TrackBar1)
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 50
	Timer1.Start
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub

